<?php
/////////////////////////////////////////////////////////////////////////////////////
// IPTable log analyzer
// Copyright (C) 2002 Gerald GARCIA
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Plac<B2>e - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact author : gege@gege.org
/////////////////////////////////////////////////////////////////////////////////////

// $Id: TopPorts.php,v 1.6 2002/11/27 18:44:08 gege Exp $

Class TopPorts {
    
  function TopPorts() {
  }

  function display() {

    $cache = new Cache();

    $str = $cache->get("TopPorts");
    if (strlen($str)==0) {
      print "<!-- The module is regenerated -->\n";
      $str = $this->generate();
      $cache->put("TopPorts",$str);
    }
    print $str;
  }

  function generate() {

    $query = "select port_dest as port, count(date) as nb from filtered_logs where port_dest <> 0 group by port_dest order by nb desc limit 10";
    $result = mysql_query ($query) or die ("Unable to query log table");
    
    $out .= "<table width='100%'>\n";
    $out .= "<tr class='ModuleTabTitle'><td>Port</td><td>Number</td><td>Nb</td></tr>\n";
    while($line = mysql_fetch_object($result)){

      $port_name=findPortNameFromNumber($line->port);

      $out .= "<tr class='TopDomainsEntry'>";
      $out .= "<td><a href='to_port.php?port=$line->port'>";
      if (strlen($port_name)!=0) { $out .= "$port_name"; } else { $out .= "unknown"; }
      $out .= "</a></td>";
      $out .= "<td><a href='to_port.php?port=$line->port'>$line->port</a></td>";
      $out .= "<td>$line->nb</td></tr>\n";
    }
    $out .= "</table>\n";

    return $out;
  }
}

?>