<?php
/////////////////////////////////////////////////////////////////////////////////////
// IPTable log analyzer
// Copyright (C) 2002 Gerald GARCIA
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Plac<B2>e - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact author : gege@gege.org
/////////////////////////////////////////////////////////////////////////////////////

// $Id: DatabaseStats.php,v 1.4 2002/11/27 18:44:08 gege Exp $

require("utils/Misc.php");

Class DatabaseStats {

  var $date = 10000;

  function DatabaseStats($aDate) {
    $this->date=$aDate;
  }

  function display() {
    
    $cache = new Cache();

    $str = $cache->get("DatabaseStats");
    if (strlen($str)==0) {
      print "<!-- The module is regenerated -->\n";
      $str = $this->generate();
      $cache->put("DatabaseStats",$str);
    }
    print $str;

  }

  function generate() {
    global $dateToString;

    $query = "SELECT count(date) FROM logs";
    $result = mysql_query ($query) or die ("Unable to query log table");
    
    $line = mysql_fetch_array($result);

    $out .= "<table>";
    $out .= "<tr class='DatabaseStats'><td align='right'>$line[0]</td><td>packets in database</td></tr>\n";

    $query = "SELECT count(date) FROM filtered_logs";
    $result = mysql_query ($query) or die ("Unable to query log table");
    
    $line = mysql_fetch_array($result);

    $out .= "<tr class='DatabaseStats'><td align='right'>$line[0]</td><td>packets younger than ".$dateToString[$this->date]."</td></tr>";

    $query = "SELECT count(date) FROM logs where TO_DAYS(NOW()) - TO_DAYS(date) < 1";
    $result = mysql_query ($query) or die ("Unable to query log table");
    
    $line = mysql_fetch_array($result);

    $out .= "<tr class='DatabaseStats'><td align='right'>$line[0]</td><td>packets today</td></tr>";

    $out .= "</table>";

    $out .= "<span class='DatabaseStats'>First was at ";

    $query = "SELECT min(date) as max FROM logs";
    $result = mysql_query ($query) or die ("Unable to query log table");
    
    $line = mysql_fetch_array($result);
    $out .= "$line[0]</span>";
  
    $out .= "<br>";
 
    $out .= "<span class='DatabaseStats'>Last was at ";

    $query = "SELECT max(date) as max FROM logs";
    $result = mysql_query ($query) or die ("Unable to query log table");
    
    $line = mysql_fetch_array($result);
    $out .= "$line[0]</span>";

    return $out;

  }
}

?>