<?php
/////////////////////////////////////////////////////////////////////////////////////
// IPTable log analyzer
// Copyright (C) 2002 Gerald GARCIA
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Plac<B2>e - Suite 330, Boston, MA  02111-1307, USA.
//
// Contact author : gege@gege.org
/////////////////////////////////////////////////////////////////////////////////////

// $Id: TopHosts.php,v 1.4 2002/11/27 18:44:08 gege Exp $

require_once("utils/Db.php");
require_once("utils/Cache.php");

Class TopHosts {

  function TopHosts() {
  }

  function generate() {
    global $ignored_list;
    $query = "select ip_src, name_src, count(date) as nb from filtered_logs group by ip_src order by nb desc limit 10";
    $result = mysql_query ($query) or handleDBError("Unable to query log table");
    
    $out .= "<table width='100%'>\n";
    $out .= "<tr class='ModuleTabTitle'><td>Host</td><td>Nb</td></tr>\n";
    while($line = mysql_fetch_object($result)){
      $out .= "<tr class='TopHostEntry'><td>";
      $out .= "<a href='from_host.php?ip=$line->ip_src'>";
      if (strcmp($line->name_src,"unknown")==0) {
	$out .= $line->ip_src;
      } else {
	$out .= $line->name_src;
      }
      $out .= "</a>";
      $out .= "</td><td>$line->nb</td></tr>\n";
    }
    $out .= "</table>\n";

    return $out;
  }

  function display() {

    $cache = new Cache();

    $str = $cache->get("TopHosts");
    if (strlen($str)==0) {
      print "<!-- The module is regenerated -->\n";
      $str = $this->generate();
      $cache->put("TopHosts",$str);
    }
    print $str;
    
  }
}

?>